###########################################################################
#
#   Copyright (c) 2000 Morten W. Petersen <morten@esol.no>
#	Copyright (c) 2000 Thingamy Ltd.
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
#    MA 02111-1307 USA
#
#
###########################################################################

# $Author: morten $
# $Revision: 1.2 $


__doc__ = 'Documentation string.'
__version__ = '0.1.0'

from Globals import HTMLFile
from Globals import Persistent
from Globals import default__class_init__
import Acquisition
import AccessControl.Role
import OFS.Folder
import OFS.DTMLMethod
import address_book_contact
import base_item


address_book_add_redirect = HTMLFile('address_book_add_redirect', globals())
manage_add_address_book_form = HTMLFile('address_book_add', globals())


def manage_add_address_book(self, id, title, REQUEST=None):
    "Add an instance of the address_book class"
    self._setObject(id, address_book(id, title))

    if REQUEST is not None:

        return self.manage_main(self, REQUEST)


class address_book(
	OFS.Folder.Folder,
	Persistent,
	Acquisition.Implicit,
	AccessControl.Role.RoleManager,
	base_item.base_item
	):
	"Documentation string"

	product_name = 'AddressBook'

	meta_type = 'AddressBook'
	icon = 'misc_/AddressBook/Folder_icon.gif'

	_properties = (
		{'id':'title', 'type':'string'},
		)

	# FIXME
	#meta_types = (
	#{'name':'AddressBookContactSort', 'action':'manage_add_address_book_contact_sort_form'},
	#)

	meta_types = (
		{'name':'AddressBookContact', 'action':'manage_add_address_book_contact_form'},
		)

	manage_add_address_book_contact_form = address_book_contact.manage_add_address_book_contact_form
	manage_add_address_book_contact = address_book_contact.manage_add_address_book_contact
	address_book_contact_add_company_information = address_book_contact.address_book_contact_add_company_information

	__ac_permissions__ = (
		('View management screens',
		 ('manage_tabs', 'manage_main')),
		('Change Permissions',
		 ('manage_access',)),
		('Add AddressBookContact',
		 ('manage_add_address_book_contact', 'manage_add_address_book_contact_form')),
		('View AddressBooks',
		 ('',)),
		)

	index_html = HTMLFile('address_book_index', globals())


	def get_unique_id(self):
		"""Returns a unique identifier."""


		try:

			return self.getParentNode().get_unique_id()

		except AttributeError:

			self.counter = self.counter + 1

			return self.counter


	def __init__(self, id, title=''):
		"Initialize the class instance"

		self.id = id
		self.title = title

		self.counter = 0


		OFS.DTMLMethod.addDTMLMethod(self, 'standard_html_header',
									 'standard_html_header',
									 open('%s/Products/%s/standard_html_header.dtml' % \
										  (SOFTWARE_HOME, self.product_name)).read())
										  
		OFS.DTMLMethod.addDTMLMethod(self, 'standard_html_footer',
									 'standard_html_footer',
									 open('%s/Products/%s/standard_html_footer.dtml' % \
										  (SOFTWARE_HOME, self.product_name)).read())

		OFS.DTMLMethod.addDTMLMethod(self, 'standard_css', 'standard_css',
									 open('%s/Products/%s/standard_css.dtml' % \
										  (SOFTWARE_HOME, self.product_name)).read())


default__class_init__(address_book)

